%Reading the input audio data
infile = 'voz1.wav' ;
% Name of the Input file
[x, Fs, bits]=wavread(infile);
%
sound(x,Fs);
%
%Plotting the input signal
plot([1:length(x)]/1000,128*x) ;
title ('original speech signal')
xlabel('Samples (x1000)');  ylabel('Sample Values');
print -dtiff plot.tiff
pause;
%
%Calculating Power spectral density
hann_wind = round(2048*0.8) ;
[Px,F] = psd(x,2048,Fs,[],hann_wind); % power spectral density of the input signal
plot(F/1000,10*log10(Px))
xlabel('Frequency (in KHz)'); ylabel('Power Spectral Density (in dB)');
print -dtiff plot.tiff
pause;
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Highpass Filtering
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hcutoff = 4000 ;       % cutoff frequency in Hz
wp = hcutoff/(Fs/2) ;       % Normalized cutoff
filt_high = fir1(64,wp,'high') ;
%Plotting the LPF frequency characteristics
[H, w] = freqz(filt_high,1,512);
HdB = 20*log10(abs(H)) ;
plot((w/pi)*(Fs/2000), HdB), grid
xlabel('Frequency  (in KHz)')
ylabel('Filter Gain (in dB)');
print -dtiff plot.tiff
%Highpass filtering the audio signal
x_hpf = filter(filt_high,1,x) ;
% scale up the output
x_hpf=x_hpf./max(0.1,max(abs(x_hpf))) ;
% Write the output signal as a wav file
wavwrite(x_hpf,Fs,8,'voz1_hpf.wav');
%
sound(x_hpf,Fs);
pause;
%
%Calculating Power spectral density
hann_wind = round(1024*0.8) ;
%power specttral density of the lowpass output
[Px_hpf,F] = psd(x_hpf,1024,Fs,[],hann_wind); 
plot(F/1000,10*log10(Px_hpf))
xlabel('Frequency (in KHz)');
ylabel('PSD (in dB)');
print -dtiff plot.tiff
%
